/*
	MessageDeliverer
	rimuove i messagi in coda e li scrive su un ObjectOutputStream
*/

package NetNode ;

import java.io.*;
import java.net.* ;

public class MessageDeliverer extends Thread {
    protected Thread parent;
	protected Queue messageQueue ;
	protected ObjectOutputStream oObjStream ;
  
	public MessageDeliverer (Thread parent, Queue q, ObjectOutputStream o) {
		super ();
		this.parent = parent;
		messageQueue = q ;
		oObjStream = o ;
	}

	public void run () {
		NodeMessage message ;
		try {
			while ( true ) {
				message = (NodeMessage) messageQueue.remove() ;
				Print( "Spedisco: " + message ) ;
				oObjStream.writeObject( message ) ;
			}
		} catch (IOException ex) {
			ex.printStackTrace() ;
			if( parent != null ) 
			    parent.stop ();
		}
	}
	
	protected void Print( String s ) {	 
		System.out.println( "(" + parent.getName() + "): " + s ) ;
	}
}

