/*
	MessageReceiver
	legge i messaggi da un ObjectInputStream e li inserisce in una coda
*/

package NetNode ;

import java.io.*;
import java.net.* ;

public class MessageReceiver extends Thread {
    protected Thread parent;
	protected Queue messageQueue ;
	protected ObjectInputStream iObjStream ;

	public MessageReceiver (Thread parent, Queue q, ObjectInputStream i) {
		super ();
		this.parent = parent;
		messageQueue = q ;
		iObjStream = i ;
	}

	public void run () {
		NodeMessage message ;
		try {
			while ( true ) {
				message = (NodeMessage) iObjStream.readObject() ;
				messageQueue.add( message ) ;
			}
		} catch ( ClassNotFoundException ce ) {
		    ce.printStackTrace() ;
		} catch (IOException ex) {
			ex.printStackTrace() ;
			if( parent != null )
			    parent.stop ();
		}
	}
}

