package NetNode ;

public class NodeMessage implements java.io.Serializable {
	// campi del messaggio
    	public String Source ; // loc di chi spedisce
    	public String Dest ; // loc del destinatario
	public String ProcessName ; // nome del processo che spedisce
	public int OpCode ; // operazione richiesta
	public Object Content ; // Tupla o Processo

	public NodeMessage( String source, String dest,
				String processname, int opcode, Object content ) {
		Source = source ;
		Dest = dest ;
		ProcessName = processname ;
		OpCode = opcode ;
		Content = content ;
	}	

	public String toString() {
		return "< " + Source + ", " + Dest + ", " + ProcessName + 
			", " + OpCode + ", " + Content + " >" ;
	}
}
